<template>
  <v-card outlined flat elevation="0" class="panel">
    <v-row class="pl-5 pr-5" justify="space-between" style="margin: 0px;">
    </v-row>
    <v-row class="pl-5 pr-5" justify="space-between" style="margin: 0px;">
      <v-col sm="5">
        <v-checkbox
          label="Shfaqni të gjithë klientët"
          :disabled="!disabled"
          v-model="displayAll"
        />
      </v-col>
      <v-col sm="4">
        <search-input v-model="search" />
      </v-col>
    </v-row>
    <v-data-table
      dense
      :headers="headers"
      :items="data"
      :loading="loading"
      :options.sync="pagination"
      :server-items-length="totalRecords"
      :footer-props="{
        'items-per-page-options': [5, 10, 15],
      }"
      outlined
      show-select
      @item-selected="rowSelected"
      v-model="selected"
    >
      <template v-slot:[`item.status`]="row">
        <v-chip
          class="ma-2 status"
          :color="row.item.status_id === 2 ? 'red' : 'green'"
          small
        >
          {{ row.item.status_id === 2 ? 'Inaktive' : 'Aktive' }}
        </v-chip>
      </template>
      <template v-slot:[`item.add_client`]="row">
        <v-simple-checkbox
          v-model="row.item.selected"
          @input="selectClient(row.item)"
        />
      </template>
      <template v-slot:[`item.actions`]="row">
        <f-edit-btn @click="$emit('edit-client', row.item.id)" />
        <v-btn
          icon
          color="green"
          class="action-btn"
          title="Kreditet"
          @click="showReceipts(row.item)"
        >
          <v-icon>mdi-cash</v-icon>
        </v-btn>
        <f-delete-btn @click="deleteClient(row.item.id)" />
      </template>
    </v-data-table>
    <v-dialog width="30%" v-model="showMessage">
      <v-card>
        <v-card-title>
          Sukses
        </v-card-title>
        <v-card-subtitle>
          {{ selectedName }} u shtua me sukses
        </v-card-subtitle>
      </v-card>
    </v-dialog>
    <portal to="destination">
      <div class="portal-wrapper">
        <h3>
          Klientet
        </h3>
      </div>
    </portal>
    <portal to="cto-topmenu">
      <div style="display: flex; align-content: center;">
        <download-excel
          class="export-button ma-2"
          :data="dataToExport"
          :fields="exportFields"
          worksheet="Klientët"
          :name="`Klientët_${todayDate}`"
        >
          Eksporto<v-icon right dark small>mdi-file-download</v-icon>
        </download-excel>
        <file-upload
          label="Klient"
          :api="`api/crm/import-clients?sector_id=${sectorId}`"
          :downloadApi="`api/download-clients-template?sector_id=${sectorId}`"
        />
        <f-action-btn icon="mdi-plus" @click="$emit('create-client')" />
      </div>
    </portal>
  </v-card>
</template>

<script lang="ts">
import api from '../../../plugins/api'
import axios from 'axios'
import { Component, Watch, Mixins } from 'vue-property-decorator'
import Table from '../../../plugins/table'
import FActionBtn from '../../../components/buttons/FActionBtn.vue'
import FEditBtn from '../../../components/buttons/FEditBtn.vue'
import FDeleteBtn from '../../../components/buttons/FDeleteBtn.vue'
import SearchInput from '../../../components/inputs/SearchInput.vue'
import FileUpload from '../../../components/inputs/FileUploader.vue'

const datatableHeader = [
  { text: 'Id', value: 'id' },
  { text: 'NUIS', value: 'nuis' },
  { text: 'Klienti', value: 'name' },
  {
    text: 'Statusi',
    value: 'status',
    sortable: false,
  },
  {
    text: 'Shto klient ne grup',
    value: 'add_client',
    sortable: false,
  },
  {
    text: 'Veprimet',
    value: 'actions',
    sortable: false,
  },
]

const exelHeaders = {
  Id: 'id',
  NUIS: 'nuis',
  Klienti: 'name',
  Statusi: 'status_id',
}
@Component({
  components: { SearchInput, FileUpload, FActionBtn, FEditBtn, FDeleteBtn },
})
export default class ClientDatatable extends Mixins(Table) {
  displayAll = true
  disabled = true
  loading = false
  data = []
  totalRecords = 0
  selectedId = null
  selected = []
  showMessage = false
  selectedName = null
  headers = datatableHeader
  sectorId = 1
  exportFields = exelHeaders
  todayDate = new Date().toLocaleDateString('en-gb')

  @Watch('displayAll')
  display() {
    this.fetchData()
  }
  mounted() {
    this.loadClientsData()
  }
  fetchData() {
    const query = this.prepareQuery({
      get_all: this.displayAll ? 1 : 0,
      group_id: this.selectedId,
    })
    this.loading = true
    api()
      .get(`/api/crm/clients/${query}`)
      .then(response => {
        console.log('response.data.data', response.data.meta.total)
        this.data = response.data.data
        this.totalRecords = response.data.meta.total
      })
      .catch(err => {
        console.log('-------> error ::: ', err)
      })
      .finally(() => {
        console.log('fghjkljkjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj')

        this.loading = false
      })
  }
  loadClientsData() {
    this.$root.$on('nodeSelected', id => {
      this.selectedId = id
      this.disabled = true
      this.displayAll = false
      this.fetchData()
    })
  }
  selectClient(client) {
    if (client.selected) {
      this.addClientToGroup(client)
    } else {
      this.deleteClientFromGroup(client.id)
    }
  }
  addClientToGroup(client) {
    api()
      .post(`api/crm/client-group/${this.selectedId}/clients`, {
        client_id: client.id,
      })
      .then(() => {
        this.showMessage = true
        this.selectedName = client.name
      })
  }
  deleteClientFromGroup(id) {
    api()
      .delete(`api/crm/client-group/${this.selectedId}/clients/${id}`)
      .then(() => {
        this.fetchData()
      })
  }
  deleteClient(id) {
    if (confirm('Jeni i sigurtë për fshirjen e ketij klienti?')) {
      api()
        .delete(`api/crm/clients/${id}`)
        .then(() => {
          this.fetchData()
        })
    }
  }
  showReceipts(client) {
    this.$router.push({
      name: 'ClientReceipts',
      params: {
        id: client.id,
        clientName: client.name,
      },
    })
  }
  rowSelected() {
    // this.$nextTick(() => {
    //   console.log(this.selected)
    // })
  }
  get dataToExport() {
    return this.selected.length != 0 ? this.selected : this.data
  }
}
</script>
<style scoped>
.action-btn {
  margin: 3px 3px;
}
.status {
  color: #fff;
  width: 100px;
  display: flex;
  justify-content: center;
}
.export-button {
  background-color: #30488b;
  text-transform: uppercase;
  font-size: 80%;
  font-weight: 500;
  color: white;
  padding: 5px 10px;
  border-radius: 5px;
  cursor: pointer;
}
.export-button:hover {
  background-color: rgb(48, 72, 139, 0.95);
}
</style>
